<h1>Add note form</h1>
<form [formGroup]="addNoteForm" (ngSubmit)="submit()">
  <mat-form-field appearance="fill">
    <mat-label>Title</mat-label>
    <input
      matInput
      type="text"
      id="title"
      formControlName="title"
    />
    <mat-error *ngIf="addNoteForm.controls.title.hasError('required')">
      Required field
    </mat-error>
    <mat-error *ngIf="addNoteForm.controls.title.hasError('maxlength')">
      Title length should not be greater than {{TITLE_MAX_LENGTH}}
    </mat-error>
  </mat-form-field>
  <mat-form-field appearance="fill">
    <mat-label>Content</mat-label>
    <textarea matInput
              id="content"
              formControlName="content"
              cdkTextareaAutosize
              #autosize="cdkTextareaAutosize"
              cdkAutosizeMinRows="5"
              cdkAutosizeMaxRows="20"
    >
    </textarea>
    <mat-error *ngIf="addNoteForm.controls.content.hasError('required')">
      Required field
    </mat-error>
    <mat-error *ngIf="addNoteForm.controls.content.hasError('maxlength')">
      Content length should not be greater than {{CONTENT_MAX_LENGTH}}
    </mat-error>
  </mat-form-field>
  <mat-form-field appearance="fill">
    <mat-label>Expiry Date</mat-label>
    <input
      matInput
      id="expiryDate"
      formControlName="expiryDate"
      [matDatepicker]="picker"
      [min]="MIN_EXPIRY_DATE"
      [max]="MAX_EXPIRY_DATE"
    >
    <mat-hint>DD/MM/YYYY</mat-hint>
    <mat-datepicker-toggle matIconSuffix [for]="picker"></mat-datepicker-toggle>
    <mat-datepicker #picker></mat-datepicker>
    <mat-error *ngIf="addNoteForm.controls.expiryDate.hasError('required')">
      Required field
    </mat-error>
    <mat-error *ngIf="addNoteForm.controls.expiryDate.hasError('dateRange')">
      Date is out of range
    </mat-error>
  </mat-form-field>
  <ng-container formGroupName="password">
    <mat-form-field appearance="fill" [color]="passwordComponent.color">
      <mat-label>Password</mat-label>
      <mat-pass-toggle-visibility #toggle matSuffix></mat-pass-toggle-visibility>
      <input #password
             required
             matInput
             id="password"
             formControlName="password"
             [type]="toggle.type"
      />
      <mat-error *ngIf="addNoteForm.controls.password.controls.password.hasError('required')">
        Required field
      </mat-error>
      <mat-error *ngIf="addNoteForm.controls.password.controls.password.hasError('minlength')">
        Password should not be smaller than {{PASSWORD_MIN_LENGTH}}
      </mat-error>
      <mat-error *ngIf="addNoteForm.controls.password.controls.password.hasError('maxlength')">
        Password should not be greater than {{PASSWORD_MAX_LENGTH}}
      </mat-error>
      <mat-hint align="end" aria-live="polite">
        {{password.value.length}} / {{passwordComponent.max}}
      </mat-hint>
    </mat-form-field>
    <mat-password-strength
      #passwordComponent
      [password]="password.value"
      [min]="PASSWORD_MIN_LENGTH"
      [max]="PASSWORD_MAX_LENGTH"
    ></mat-password-strength>
    <mat-password-strength-info
      *ngIf="!addNoteForm.controls.password.pristine"
      [passwordComponent]="passwordComponent"
    ></mat-password-strength-info>
    <mat-form-field appearance="fill">
      <mat-label>Password Confirmation</mat-label>
      <input #password
             required
             matInput
             id="passwordConfirmation"
             formControlName="passwordConfirmation"
             [type]="toggle.type"
      />
      <mat-error *ngIf="addNoteForm.controls.password.controls.passwordConfirmation.hasError('required')">
        Required field
      </mat-error>
      <mat-error *ngIf="addNoteForm.controls.password.controls.passwordConfirmation.hasError('minlength')">
        Password should not be smaller than {{PASSWORD_MIN_LENGTH}}
      </mat-error>
      <mat-error *ngIf="addNoteForm.controls.password.controls.passwordConfirmation.hasError('maxlength')">
        Password should not be greater than {{PASSWORD_MAX_LENGTH}}
      </mat-error>
      <mat-error *ngIf="addNoteForm.controls.password.hasError('confirmationMismatch')">
        Confirmation Password does not match to Password
      </mat-error>
    </mat-form-field>
  </ng-container>
  <button *ngIf="!isLoading"
          mat-button
          type="submit"
          color="primary"
          [disabled]="addNoteForm.invalid"
  >
    Submit
  </button>
  <app-spinner *ngIf="isLoading"></app-spinner>
</form>
